unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Grids;

type

  { TForm1 }

  TForm1 = class(TForm)
    StringGrid1: TStringGrid;
    procedure FormCreate(Sender: TObject);
    procedure StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
      aState: TGridDrawState);
  private

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

function GetCellHeight(AGrid: TStringGrid; ACol, ARow: Integer): Integer;
var
  r: Integer;
  i: Integer;
  L: TStringList;
  h: Integer;
  bmp: TBitmap;
begin
  bmp := TBitmap.Create;
  bmp.Canvas.Font.Assign(AGrid.Font);
  L := TStringList.Create;
  try
    L.Text := AGrid.Cells[ACol, ARow];
    if L.Count > 0 then
      Result := bmp.Canvas.TextHeight('Tg') * L.Count + 2 * constCellPadding
    else
      Result := AGrid.DefaultRowHeight;
  finally
    L.Free;
    bmp.Free;
  end;
end;

procedure AutoRowHeight(AGrid: TStringGrid; ARow: Integer);
var
  h, hmax : Integer;
  col: Integer;
begin
  hmax := 0;
  for col := 0 to AGrid.ColCount-1 do begin
    h := GetCellHeight(AGrid, col, ARow);
    if h > hmax then hmax := h;
  end;
  AGrid.RowHeights[ARow] := hmax;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  r: Integer;
begin
  with StringGrid1 do begin
    Cells[0, 1] := '1';
    Cells[0, 2] := '2';
    Cells[0, 3] := '3';
    Cells[0, 4] := '4';

    Cells[1, 1] := 'This is line 1,' + LineEnding + 'and this is line 2.';
    Cells[1, 2] := 'ABC' + LineEnding + 'DEF' + LineEnding + 'GHI';
    Cells[1, 3] := '1' + LineEnding + '2' + LineEnding + '3' + LineEnding + '456';
    Cells[1, 4] := 'Lazarus' + LineEnding+ 'TStringGrid demo';
  end;

  for r := 0 to StringGrid1.RowCount-1 do
    AutoRowHeight(StringGrid1, r);

  StringGrid1.ColWidths[0] := 30;
  StringGrid1.ColWidths[1] := 150;
end;

procedure TForm1.StringGrid1PrepareCanvas(sender: TObject; aCol, aRow: Integer;
  aState: TGridDrawState);
var
  ts: TTextStyle;
begin
  ts := StringGrid1.Canvas.TextStyle;
  ts.Wordbreak := true;
  ts.SingleLine := false;
  StringGrid1.Canvas.TextStyle := ts;
end;

end.

